local STRINGS = GLOBAL.STRINGS
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
GetClock = GLOBAL.GetClock
GetPlayer = GLOBAL.GetPlayer

STRINGS.NAMES.EVILFLOWERHAT = "Evil Garland"
STRINGS.RECIPE_DESC.EVILFLOWERHAT = "Something to chill the bones."

STRINGS.NAMES.FLOWER_CORRUPT = "Corrupted Flower"

PrefabFiles = {
	"dementor",
	"evilflowerhat",
	"flower_corrupt"
}

Assets = {
    Asset( "ATLAS", "images/saveslot_portraits/dementor.xml" ),
	Asset( "IMAGE", "images/saveslot_portraits/dementor.tex" ),
	
    Asset( "ATLAS", "images/selectscreen_portraits/dementor.xml" ),
	Asset( "IMAGE", "images/selectscreen_portraits/dementor.tex" ),
	
    Asset( "ATLAS", "images/selectscreen_portraits/dementor_silho.xml" ),
	Asset( "IMAGE", "images/selectscreen_portraits/dementor_silho.tex" ),
	
    Asset( "ATLAS", "bigportraits/dementor.xml" ),
	Asset( "IMAGE", "bigportraits/dementor.tex" ),
}

AddSimPostInit(function(inst)
	-- Copied from Wilton --
	if GetPlayer().prefab == "dementor" then
		inst.HUD.controls.status.brain:SetPosition( inst.HUD.controls.status.stomach:GetPosition() )
		inst.HUD.controls.status.stomach:Hide()
		inst.components.eater:SetInsectivore()
		local evilflowerhatRecipe = GLOBAL.Recipe("evilflowerhat", {Ingredient("petals_evil", 12)}, RECIPETABS.DRESS, {SCIENCE=0} )
		evilflowerhatRecipe.atlas = "images/inventoryimages/evilflowerhat.xml"
	end
end)

-- The few foods Dementors can eat, typed "INSECT" (see Wilton mod) --
AddPrefabPostInit("petals", function(inst)
	if GetPlayer().prefab == "dementor" then
		inst.components.edible.foodtype = "INSECT" 
		print "caneatflowers"
		inst.components.edible.sanityvalue = -TUNING.SANITY_SMALL
		inst.components.edible.healthvalue = -TUNING.HEALING_TINY
	end
end)

AddPrefabPostInit("flower", function(inst)
	if GetPlayer().prefab == "dementor" then
		inst.components.pickable.onpickedfn = function(inst, picker)
			if picker and picker.components.sanity then
				picker.components.sanity:DoDelta(-TUNING.SANITY_TINY)
			end	
			inst:Remove()
		end
		inst:AddComponent("sanityaura")
	    inst.components.sanityaura.aura = -TUNING.SANITYAURA_SMALL
	    inst:AddComponent("health")
	    inst.components.health:SetMaxHealth(15)
	end
end)

AddPrefabPostInit("petals_evil", function(inst)
	if GetPlayer().prefab == "dementor" then
		inst.components.edible.foodtype = "INSECT" 
		print "caneatflowers"
		inst.components.edible.sanityvalue = TUNING.SANITY_SMALL 
	    inst.components.edible.healthvalue = TUNING.HEALING_TINY
	    inst.components.edible:SetOnEatenFn(function(inst, eater) end) -- To cancel the default sanity loss of evil petals
	end
end)

AddPrefabPostInit("flower_evil", function(inst)
	if GetPlayer().prefab == "dementor" then
		inst.components.pickable.onpickedfn = function(inst, picker)
			if picker and picker.components.sanity then
				picker.components.sanity:DoDelta(TUNING.SANITY_TINY)
			end	
			inst:Remove()
		end
	    inst.components.sanityaura.aura = 0 -- To cancel the default sanity aura of evil flowers
	end
end)

AddPrefabPostInit("nightmarefuel", function(inst)
	if GetPlayer().prefab == "dementor" then 
		print "caneatnightmarefuel"
		inst:AddComponent("edible")
	    inst.components.edible.healthvalue = TUNING.HEALING_MED
	    inst.components.edible.hungervalue = 0
	    inst.components.edible.foodtype = "INSECT"
	end
end)

-- The garlands have reversed effects too --
AddPrefabPostInit("flowerhat", function(inst)
	if GetPlayer().prefab == "dementor" then
		print "reversegarland"
		inst.components.dapperness.dapperness = TUNING.CRAZINESS_SMALL
		inst.components.edible.healthvalue = -TUNING.HEALING_SMALL
		inst.components.edible.sanityvalue = TUNING.SANITY_MED
		inst.components.edible.foodtype = "INSECT"
	end
end)

-- Since you're soulstealing, a lot of creatures start dropping their souls on death (as nightmare fuel) --
AddPrefabPostInit("rabbit", function(inst)
	if GetPlayer().prefab == "dementor" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 0.2)
	end
end)
AddPrefabPostInit("crow", function(inst)
	if GetPlayer().prefab == "dementor" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 0.1)
	end
end)
AddPrefabPostInit("robin", function(inst)
	if GetPlayer().prefab == "dementor" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 0.1)
	end
end)
AddPrefabPostInit("robin_winter", function(inst)
	if GetPlayer().prefab == "dementor" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 0.1)
	end
end)
AddPrefabPostInit("perd", function(inst)
	if GetPlayer().prefab == "dementor" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 0.5)
	end
end)
AddPrefabPostInit("penguin", function(inst)
	if GetPlayer().prefab == "dementor" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 0.3)
	end
end)
AddPrefabPostInit("bee", function(inst)
	if GetPlayer().prefab == "dementor" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 0.1)
	end
end)
AddPrefabPostInit("killerbee", function(inst)
	if GetPlayer().prefab == "dementor" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 0.1)
	end
end)
AddPrefabPostInit("beefalo", function(inst)
	if GetPlayer().prefab == "dementor" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 1)
	end
end)
AddPrefabPostInit("babybeefalo", function(inst)
	if GetPlayer().prefab == "dementor" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 1)
	end
end)
AddPrefabPostInit("butterfly", function(inst)
	if GetPlayer().prefab == "dementor" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 0.1)
	end
end)
AddPrefabPostInit("bunnyman", function(inst)
	if GetPlayer().prefab == "dementor" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 1)
	end
end)
AddPrefabPostInit("koalefant_summer", function(inst)
	if GetPlayer().prefab == "dementor" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 1)
	end
end)
AddPrefabPostInit("koalefant_winter", function(inst)
	if GetPlayer().prefab == "dementor" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 1)
	end
end)
AddPrefabPostInit("pigman", function(inst)
	if GetPlayer().prefab == "dementor" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 1)
	end
end)
AddPrefabPostInit("pigguard", function(inst)
	if GetPlayer().prefab == "dementor" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 1)
	end
end)
AddPrefabPostInit("smallbird", function(inst)
	if GetPlayer().prefab == "dementor" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 1)
	end
end)
AddPrefabPostInit("teenbird", function(inst)
	if GetPlayer().prefab == "dementor" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 1)
	end
end)
AddPrefabPostInit("frog", function(inst)
	if GetPlayer().prefab == "dementor" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 0.2)
	end
end)
AddPrefabPostInit("walrus", function(inst)
	if GetPlayer().prefab == "dementor" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 1)
	end
end)
AddPrefabPostInit("little_walrus", function(inst)
	if GetPlayer().prefab == "dementor" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 1)
	end
end)
AddPrefabPostInit("krampus", function(inst)
	if GetPlayer().prefab == "dementor" then
		inst.components.lootdropper:AddChanceLoot("nightmarefuel", 1)
	end
end)
AddPrefabPostInit("ghost", function(inst)
	if GetPlayer().prefab == "dementor" then
		inst:AddComponent("lootdropper")
		inst.components.lootdropper:SetLoot({"nightmarefuel"})
	end
end)

AddModCharacter("dementor")