local assets=
{
	Asset("ANIM", "anim/evilflowerhat.zip"),
	Asset("IMAGE", "images/inventoryimages/evilflowerhat.tex"),
	Asset("ATLAS", "images/inventoryimages/evilflowerhat.xml")
	
}

local function onunequip(inst, owner)
    owner.AnimState:Hide("HAT")
    owner.AnimState:Hide("HAT_HAIR")
    owner.AnimState:Show("HAIR_NOHAT")
    owner.AnimState:Show("HAIR")

	if owner:HasTag("player") then
        owner.AnimState:Show("HEAD")
		owner.AnimState:Hide("HEAD_HAIR")
	end
end

local function opentop_onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_hat", "hateflower", "swap_hat")
    owner.AnimState:Show("HAT")
    owner.AnimState:Hide("HAT_HAIR")
    owner.AnimState:Show("HAIR_NOHAT")
    owner.AnimState:Show("HAIR")
    
    owner.AnimState:Show("HEAD")
    owner.AnimState:Hide("HEAD_HAIR")
end

local function generic_perish(inst)
    inst:Remove()
end

local function fn(Sim)
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("flowerhat")
    inst.AnimState:SetBuild("hateflower") -- Manually changed from hat_flower in build.bin...
    inst.AnimState:PlayAnimation("anim")

    inst:AddTag("hat")

    inst:AddComponent("inspectable")
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/evilflowerhat.xml"
    inst:AddComponent("tradable")
    
    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.HEAD
    inst.components.equippable:SetOnEquip(opentop_onequip)
    inst.components.equippable:SetOnUnequip(onunequip)

	inst:AddComponent("dapperness")
	inst.components.dapperness.dapperness = -TUNING.CRAZINESS_SMALL

	inst:AddComponent("edible")
	inst.components.edible.healthvalue = TUNING.HEALING_SMALL
	inst.components.edible.hungervalue = 0
	inst.components.edible.sanityvalue = TUNING.SANITY_MED
	inst.components.edible.foodtype = "INSECT" -- So that a Dementor can eat it
	
	inst:AddComponent("perishable")
	inst.components.perishable:SetPerishTime(TUNING.PERISH_FAST)
	inst.components.perishable:StartPerishing()
	inst.components.perishable:SetOnPerishFn(generic_perish)

        return inst
end

--local function fn(Sim)
--
--	inst:AddComponent("dapperness")
--	inst.components.dapperness.dapperness = TUNING.DAPPERNESS_TINY
--	
--	inst:AddComponent("edible")
--	inst.components.edible.healthvalue = TUNING.HEALING_SMALL
--	inst.components.edible.hungervalue = 0
--	inst.components.edible.sanityvalue = TUNING.SANITY_SMALL
--	inst.components.edible.foodtype = "VEGGIE"
--	
--	inst:AddComponent("perishable")
--	inst.components.perishable:SetPerishTime(TUNING.PERISH_FAST)
--	inst.components.perishable:StartPerishing()
--	inst.components.perishable:SetOnPerishFn(generic_perish)
--end

return Prefab( "common/inventory/evilflowerhat", fn, assets)